/** File CacheCLMDNR.java
* Classe astratta Java che implementa 
* i metodi per garantire la consistenza
* dei dati della cache e i metodi che 
* leggono i dati dalla rete.
* (CLMDNR = Consistency
*           Logic
*           Manager
*           Data
*           Net
*           Receiver 
@author Claudio Forlivesi
@version 1.0, 15/2/2000 
*/

import java.io.*;

public abstract class CacheCLMDNR extends CacheConsistencyLogic 
                                    implements ICacheDataLoader
{
   public abstract ICacheElem updateIsCorrect( ICacheElem oldelem, IUpdateElem news ) 
                                          throws InconsistentUpdateException;
   public abstract ITag readTag( DataInputStream datain ) 
                                          throws IOException;
   public abstract IUpdateElem readUpdateElem( DataInputStream datain ) 
                                          throws IOException;
   public abstract ICacheElem readCacheElem( DataInputStream datain ) 
                                          throws IOException;

} // CacheCLMDNR 
 

