/** File CacheClientInfo.java
* Classe Java che contiene le informazioni per permettere
* al server di identificare un suo cliente cache.
@author Claudio Forlivesi
@version 1.0, 15/2/2000 
*/

import java.net.*;

public class CacheClientInfo extends LispSimple
{
   // membri
   // porta dello snoop daemon
   private int snooperport = 0;
   // Indirizzo del client
   private InetAddress addr = null;
   // ID del client 
   private long ID;
   // thread che gestisce il cliente
   private CacheServingThread thread = null;
   // connessione attuale tra client e server
   private Socket conn = null;
   
   // funzioni di ritorno
   public int getSnoopPort() { return snooperport; }
   public InetAddress getAddress() { return addr; }
   public long getID() { return ID; }
   public CacheServingThread getServerThread() { return thread; }
   public Socket getConnection() { return conn; }
   
   // funzioni ereditate da LispSimple
   public boolean isEqual(ILispBase dat)
   { 
      return (dat instanceof CacheClientInfo) &&
                  (getID() == ((CacheClientInfo)dat).getID());
   }
   
	public boolean isLess(ILispBase dat)
   { 
      return (dat instanceof CacheClientInfo) &&
                  (getID() < ((CacheClientInfo)dat).getID());
   }
   
	public ILispBase car() { return this ; }
	public ILispBase cdr() { return this ; }
	public String toSimpleString()
	{
	   return " Client ID "+getID()+" ; Port "+getSnoopPort()+
	          " ; IP Address: "+getAddress() ;
	}

   public String toString()
   {
      return "{ "+toSimpleString()+" }";
   }
   
   // costruttore
   public CacheClientInfo( long ID,
                           InetAddress addr,
                           int snooperport,
                           CacheServingThread thread,
                           Socket conn )
   {
      this.snooperport = snooperport;
      this.addr = addr;
      this.thread = thread;
      this.ID = ID;
      this.conn = conn;
   }
   
} // CacheClientInfo     
