/** File CacheDataInfo.java
* Classe Java che contiene le informazioni per permettere
* al server di identificare i server ed i client
* connessi ad un dato in uso
@author Claudio Forlivesi
@version 1.0, 15/2/2000 
*/

import java.io.*;

public class CacheDataInfo extends LispSimple
{
   // membri
   // elemento
   protected ICacheElem elem = null;
   // lista dei clienti
   protected ILispList clientlist = LispUtils.EmptyList();
   // lista dei server su cui l'elemento  stato copiato
   protected ILispList otherservers = LispUtils.EmptyList();
   // server di provenienza
   protected CacheServerInfo source = null;
   
   // funzioni di ritorno
   public ICacheElem getElem() { return elem; }
   public ILispList getClientList() { return clientlist; }
   public ILispList getServerList() { return otherservers; }
   public CacheServerInfo getSource() { return source; }
   
   
   // funzioni ereditate da LispSimple
   public boolean isEqual(ILispBase dat)
   {  
      return (dat instanceof CacheDataInfo) &&
                  (getElem().getTag().isEqual( ((CacheDataInfo)dat).getElem().getTag()));
   }
   
	public boolean isLess(ILispBase dat)
	{ 
      return false;
   }
   
	public ILispBase car() { return this ; }
	public ILispBase cdr() { return this ; }
	 
	
	public String toSimpleString()
	{
	   return getElem().toString() + 
	          "\nServer List: "+ getServerList()+
	          "\nSource : " + getSource() +
	          "\nClient List: "+ getClientList() ;
   }

   public String toString()
   {
      return "{ "+toSimpleString()+" }";
   }
   
   // salva il dato sul file del server
   //public abstract void SaveDataToStorage() throws IOException;

   // invia il dato ad uno stream di una cache client
   //public abstract int writeImage( DataOutputStream dataout ) 
   //                                       throws IOException; 
   
   // invia il dato ad un altro server
   //public abstract int sendToServer( DataOutputStream dataout )
   //                                       throws IOException;
                                          
   // costruttore
   public CacheDataInfo( ICacheElem elem,
                         ILispList clientlist,
                         ILispList otherservers,
                         CacheServerInfo source )
   {
      this.elem = elem;
      this.clientlist = clientlist;
      this.otherservers = otherservers;
      this.source = source;
   }
   
} // CacheDataInfo     
