/** File CacheHashStorageServer.java
* Classe astratta Java che implementa  
* un server di una cache dotato di memoria 
* formata da una hash table.
@author Claudio Forlivesi
@version 1.0, 15/2/2000 
*/

import java.io.*;
import java.net.*;

public abstract class CacheHashStorageServer extends CacheStorageServer
{
   /* membri ereditati 
   // unit di memoria
      IStorageUnit memcard = null;
   */
   
   public CacheHashStorageServer( String servername, 
                                  long serverID,
                                  int serverport,
                                  boolean masterserver,
                                  ILispList brothersInfo,
                                  int priority ) throws IOException
   {
      super( servername, serverID, serverport,
             masterserver, brothersInfo, priority );
   }
   
   // nuovi metodi astratti
   // questo qui carica i dati da un file all'inizio dell'
   // esecuzione del master
   protected abstract CacheDataInfo[] UploadDataFromDisk()
                                    throws IOException;

   // questo fornisce l'hashcode dei dati in base 
   // al loro tag
   protected abstract int getHashCodeFromTag(ITag tag);   
   
   // questo qui comincia a salvare i dati su disco
   protected abstract void BeginSavingSession(HashStorageUnit source)
                                             throws IOException;                                 
                                    
   // questo qui salva un dato su disco 
   // durante una sessione di salvataggio
   protected abstract void SaveToDisk(CacheDataInfo dat)
                                             throws IOException;
                                             
   // questo qui termina di salvare i dati su disco
   protected abstract void EndSavingSession(HashStorageUnit source)
                                             throws IOException;                                 
                                    
   // metodi ereditati da CacheStorageServer
   protected IStorageUnit buildMemoryUnit() throws IOException
   {
      return new HashStorageUnit(this);
   }
   
   // metodo di CacheServer
   protected abstract CacheCLMDNR createConsistencyController();
   
} // CacheHashStorageServer

