/** File CacheServerInfo.java
* Classe Java che contiene le informazioni per permettere
* al server di identificare un altro server.
@author Claudio Forlivesi
@version 1.0, 15/2/2000 
*/

import java.net.*;
import java.io.*;

public class CacheServerInfo extends LispSimple
{
   // membri
   // nome del server
   private String name = null;
   // porta del server
   private int port = 0;
   // Indirizzo del client
   private InetAddress addr = null;
   // ID del server 
   private long ID;
   // priorit del server
   private int priority = 0;
   
   // funzioni di ritorno
   public int getPort() { return port; }
   public InetAddress getAddress() { return addr; }
   public long getID() { return ID; }
   public int getPriority() { return priority; }
   public String getName() { return name; }
   
   // funzioni ereditate da LispSimple
   public boolean isEqual(ILispBase dat)
   { 
      return (dat instanceof CacheServerInfo) &&
                  (getID() == ((CacheServerInfo)dat).getID());
   }
   
	public boolean isLess(ILispBase dat)
   { 
      return (dat instanceof CacheServerInfo) &&
                  (getPriority() < ((CacheServerInfo)dat).getPriority());
   }
   
	public ILispBase car() { return this ; }
	public ILispBase cdr() { return this ; }
	public String toSimpleString()
	{
	   return getName()+" ; ID "+getID()+" ; Port "+getPort()+
	          " ; IP Address: "+getAddress()+" ; Priority = " + getPriority();
	}

   public String toString()
   {
      return "{ "+toSimpleString()+" }";
   }
   
   // costruttore
   public CacheServerInfo( String name,
                           long ID,
                           InetAddress addr,
                           int port,
                           int priority )
   {
      this.port = port;
      this.addr = addr;
      this.name = name;
      this.ID = ID;
      this.priority = priority;
   }
   
} // CacheServerInfo     
