/** File DescrTag.java
* Classe Java che descrive un tag
* che serve ad fornire una descrizione
* dettagliata per una voce di magazzino.
@author Claudio Forlivesi
@version 1.0, 15/2/2000 
*/

import java.io.*;
import java.net.*;

public class DescrTag implements ITag  
{
   // membri
   private String name = null;
   
   public DescrTag(String name)
   {
      this.name = name.trim();
   }
   
   public boolean isEqual( ITag toCheck )
   {
      return (toCheck instanceof DescrTag) &&
                  name.equals(toCheck.toString()) ;
   }
    
   public String toString()
   {
      return name;
   }
   
   // metodi di IRawData
   
   public int writeImage( DataOutputStream dataout ) throws IOException
   {
      dataout.writeShort(MagConstants.DESCRTAG);
      dataout.writeUTF(name);
      
      return name.length() + 2;
   } 
   
} // DescrTag

