/** File ICacheChain.java
* Interfaccia Java che descrive 
* la catena degli elementi della cache.
@author Claudio Forlivesi
@version 1.0, 15/2/2000 
*/

public interface ICacheChain
{
   // ritorna !=null in caso di hit modified
   public ICacheElem shareData( ITag tag );
   
   // ritorna !=null in caso di hit modified
   public ICacheElem invalidData(ITag tag);
   
   // ritorna null in caso di miss
   public ICacheElem getData( ITag tag );
   
   // ritorna !=null in caso di hit modified
   public ICacheElem insertData( ICacheElem trdada, boolean shared );
   
   // ritorna un array dei soli oggetti modificati o null se non ve ne sono
   public ICacheElem[] flushData();
   
   // ritorna il numero degli SLOT (compresi quelli vuoti!!) della catena
   public int getSize();
   
   // ritorna lo stato di un dato, I se miss
   public int getStatus( ITag tag );
   
   // setta lo stato di un dato e ritorna il precedente, I se miss
   public int setStatus( ITag tag, int newstat );
   
}   // ICacheChain
