/** File IServer.java
* Interfaccia Java che descrive 
* il server visto dalla cache.
@author Claudio Forlivesi
@version 1.0, 15/2/2000 
*/

import java.io.*;

public interface IServer extends Runnable
{
   public String toString();
   public boolean ServerMustStop();
   public void StopServerThreads( boolean causeIsAnotherServer );
   public CacheDataInfo AskDataForReading( ITag tag, boolean externalsnoop ) throws
                                                DataIsMissingException,
                                                CollisionException,
                                                ServerPermissionException,
                                                IOException;
   public CacheDataInfo AskDataForWriting( ITag tag, boolean externalsnoop ) throws
                                                CollisionException,
                                                DataIsMissingException,
                                                ServerPermissionException,
                                                IOException;
   public void ReleaseData( ITag tag ); 

} // IServer

