/** File IStorageUnit.java
* Interfaccia Java che descrive 
* l'unit di memoria del server.
@author Claudio Forlivesi
@version 1.0, 15/2/2000 
*/

import java.io.*;

public interface IStorageUnit
{
   public CacheDataInfo LoadData( ITag tag ) throws 
                                             DataIsMissingException,
                                             ServerPermissionException,
                                             IOException;
      
   // serve a caricare l'ultimo valore valido rimasto sul server
   // a differenza di loaddata la DataIsMissingException 
   // lanciata solo se proprio il dato NON c'
   public CacheDataInfo LoadLastValidValue( ITag tag ) throws 
                                                DataIsMissingException,
                                                ServerPermissionException,
                                                IOException;
   public void SaveDataToStorage(CacheDataInfo dat) throws IOException;
   
   public void MarkDataAsInvalid(ITag tag, CacheServerInfo newsource)
                                                throws IOException;
                                                   
   public void MarkDataAsInvalidFromCache(ITag tag, CacheClientInfo newsource)
                                                throws IOException;
                                                
   public void RestoreMarkedAsInvalidDatas() throws IOException;
   
   public void closeUnit() throws IOException;
      
} // IStorageUnit

