/** File LispCompound.java
* Classe astratta Java che modella un ADT generico
* modellato sul LISP che implementa un elemento composto
@author Claudio Forlivesi
@version 1.0, 6/11/1999 
*/

public abstract class LispCompound extends LispBase 
{
	// membri
	private ILispBase dat1, dat2;
	
	// costruttori
	public LispCompound( ILispBase elem1, ILispBase elem2 ) { dat1 = elem1 ; dat2 = elem2 ; }
	
	// metodi
	public boolean isSimple() { return false ; }
   public boolean isNull() { return false ; }
   public boolean isCompound() { return true ; }
	public boolean isList() { return false ; } 
	public boolean isEqual(ILispBase dat) { return ( dat1.isEqual( dat.car() ) ) && ( dat2.isEqual( dat.cdr() ) ) ; }
	public ILispBase car() { return dat1 ; }
	public ILispBase cdr() { return dat2 ; }
	public String toString() { return "( " + toSimpleString() + " )" ; }
	public String toSimpleString() { return ( ( dat2 instanceof LispEmptyList )? dat1.toSimpleString() :
	                                          dat1.toSimpleString() + separator() + dat2.toSimpleString() ) ; }
   
   // metodi privati
   private String separator() { return " , " ; }
	
} // LispCompound


