/** File LispList.java
* Classe Java che modella un ADT generico
* modellato sul LISP che implementa una lista
@author Claudio Forlivesi
@version 1.0, 6/11/1999 
*/

public class LispList extends LispCompound implements ILispList
{
   // costruttori
   public LispList( ILispBase testa, ILispList resto )
   {
      super(testa, resto);
   }
   
   // metodi 
   public boolean isLess( ILispBase elem ) { return super.car().isLess( elem.car() ); }
   public boolean isList() { return true ; }
   public ILispBase Head() { return super.car() ; }
   public ILispList Tail() { return (ILispList)super.cdr() ; }
   public String toSimpleString()
   { 
      return ( Head().toSimpleString().equals("") ) ? Tail().toSimpleString() : 
               (Head().toSimpleString() + separator() + Tail().toSimpleString());
   }
   public String toString() 
   {
      return "( "+ toSimpleString() + " )";
   }
   private String separator() { return " ,\n"; }
   
}  // LispList
