/** File MagApp.java
* Classe Java che implementa l'applicazione client 
* per gestire un magazzino.
@author Claudio Forlivesi
@version 1.0, 15/2/2000 
*/

import java.io.*;
import java.net.*;
import java.util.*;

public class MagApp
{
   // membri
   private static CacheMag cache = null;
   private static OptionPanel optpan = null;
   
   public static void main(String[] args)
   {
      if((args == null)||(args.length == 0))
      {
         System.err.println("Sorry, but you must specify the config file.");
         return;
      }
      
      try
      {
         File config = new File(args[0]);
         BufferedReader br = new BufferedReader(
                                 new FileReader(config));
         // leggiamo il nome della cache
         String cachename = 
            (new StringTokenizer(br.readLine())).nextToken().trim();
         System.out.println("Cache "+cachename+" activating...");
         // leggiamo il suo ID NUMBER
         String line = br.readLine();
         long cacheID = Long.parseLong((new StringTokenizer(line.trim())).nextToken());
         System.out.println("ID Number is "+cacheID);
         // leggiamo le sue dimensioni
         line = br.readLine();
         int truesize = Integer.parseInt((new StringTokenizer(line.trim())).nextToken());
         // leggiamo l'indirizzo logico del server
         line = br.readLine();
         String server_logic_addr = (new StringTokenizer(line.trim())).nextToken();
         // leggiamo il numero di porta del server
         line = br.readLine();
         int serverport = Integer.parseInt((new StringTokenizer(line.trim())).nextToken());
      
         br.close();
         
         // creo la cache
         cache = new CacheMag(cachename,
                              cacheID,
                              truesize,
                              server_logic_addr,
                              serverport);
         // creo il pannello delle opzioni
         optpan = new OptionPanel(cache);
         // esecuzione
         optpan.display();
         // terminazione
         cache.closeSession();
      }
      catch(FileNotFoundException fe)
      {
         System.err.println("Unable to create the cache.");
         System.err.println("File "+ args[0] +" not found.");
         System.err.println(fe);
         fe.printStackTrace();
      }
      catch(Exception e)
      {
         System.err.println("Unable to create the cache.");
         System.err.println(e);
         e.printStackTrace();
      }
   } // main
   
} // MagApp
