/** File MagTag.java
* Classe Java che descrive un tag
* che serve ad identificare una voce di magazzino.
@author Claudio Forlivesi
@version 1.0, 15/2/2000 
*/

import java.io.*;
import java.net.*;

public class MagTag implements ITag  
{
   // membri
   private char[] code = null;
   
   // private utilities
   private char getChar(int i)
   { return code[i]; }
   
   public MagTag(String code)
   {
      MagConstants mc = new MagConstants();
      char[] c = new char[mc.MAT_CODE_LEN];
      for (int i = 0 ; i < mc.MAT_CODE_LEN ; i++)
         c[i] = '0';
      int srcEnd = (code.length() > mc.MAT_CODE_LEN)?
                        mc.MAT_CODE_LEN : code.length() ;
      int dstBegin = mc.MAT_CODE_LEN - code.length();
      dstBegin = (dstBegin < 0)? 0 : dstBegin ;
      code.getChars(0, srcEnd, c, dstBegin);
      this.code = c;
   }
   
   public MagTag(char[] code)
   {
      this(new String(code));
   }
   
   public boolean isEqual( ITag toCheck )
   {
      if(!(toCheck instanceof MagTag))
         return false;
      
      MagTag t = (MagTag)toCheck;
      
      for (int i = 0; i < MagConstants.MAT_CODE_LEN ; i++)
         if( t.getChar(i) != getChar(i) )
            return false;
      
      return true;
   }
    
   public String toString()
   {
      return (new String(code));
   }
   
   // metodi di IRawData
   public int writeImage( DataOutputStream dataout ) throws IOException
   {
      dataout.writeShort(MagConstants.MAGTAG);
      for (int i = 0; i < MagConstants.MAT_CODE_LEN ; i++)
         dataout.writeChar(code[i]);
         
      return MagConstants.MAT_CODE_LEN ;   
   } 
   
} // MagTag

