/** File MatDescr.java
* Classe Java che descrive un tag
* che serve ad fornire una descrizione
* dettagliata per una voce di magazzino.
@author Claudio Forlivesi
@version 1.0, 15/2/2000 
*/

import java.io.*;
import java.net.*;

public class MatDescr extends DescrTag implements ICacheElem  
{
   // membri
   private String descr = null;
   private MagTag code = null;
   
   public MatDescr(String name, 
                   String descr,
                   String code)
   {
      this( name, descr, new MagTag(code) );
   }

   public MatDescr(String name, 
                   String descr,
                   MagTag code)
   {
      super(name);
      this.descr = descr;
      this.code = code;
   }
   
   public ITag getTag()
   {
      return new DescrTag(super.toString());
   }
   
   public String toString()
   {
      return super.toString() + "\tcode: " + code.toString() +
             "\nDescription:\n" + descr;
   }
   
   public String getName()
   {
      return super.toString();
   }
   
   public String getCode()
   {
      return code.toString();
   }
   
   public String getDescr()
   {
      return descr;
   }
   
   // metodi di IRawData
   
   public int writeImage( DataOutputStream dataout ) throws IOException
   {
      dataout.writeShort(MagConstants.MATDESCR);
      dataout.writeUTF(super.toString());
      char[] cd = code.toString().toCharArray();
      for (int i = 0; i < MagConstants.MAT_CODE_LEN ; i++)
         dataout.writeChar(cd[i]);
      dataout.writeUTF(descr);
      
      return 1;
   } 
   
} // MatDescr


