/** File StoredMat.java
* Classe Java che contiene le info su
* di un materiale immagazzinato
* per una voce di magazzino.
@author Claudio Forlivesi
@version 1.0, 15/2/2000 
*/

import java.io.*;
import java.net.*;

public class StoredMat implements ICacheElem  
{
   // membri
   private MagTag code = null;
   private int costindollars = 0;
   private int quantity = 0;
   
   // funzioni utili
   public final int getCost() { return costindollars; }
   public final int getQuantity() { return quantity; }
   public final MagTag getCode() { return code; }
   
   public StoredMat(String code, 
                    int quantity,
                    int costindollars )
   {
      this( new MagTag(code), quantity, costindollars );
   }

   public StoredMat(MagTag code, 
                    int quantity,
                    int costindollars )
   {
      this.quantity = quantity;
      this.code = code;
      this.costindollars = costindollars;
   }
   
   public ITag getTag()
   {
      return code;
   }
   
   public String toString()
   {
      return code.toString() + "\t" +
               costindollars + " $/unit\t" + quantity + " units";
   }
   
   // metodi di IRawData
   
   public int writeImage( DataOutputStream dataout ) throws IOException
   {
      dataout.writeShort(MagConstants.STOREDMAT);
      dataout.writeInt(quantity);
      dataout.writeInt(costindollars);
      char[] cd = code.toString().toCharArray();
      for (int i = 0; i < MagConstants.MAT_CODE_LEN ; i++)
         dataout.writeChar(cd[i]);
      
      return 1;
   } 
   
} // StoredMat



