/** File UpdateOp.java
* Classe Java che contiene le info su
* di un operazione di aggiornamento del
* prezzo di costo o della quantit di
* un materiale immagazzinato.
@author Claudio Forlivesi
@version 1.0, 15/2/2000 
*/

import java.io.*;
import java.net.*;

public class UpdateOp implements IUpdateElem  
{
   // membri
   private MagTag code = null;
   private int opcost = 0;
   private int opquantity = 0;
   private short operation = MagConstants.UPDATEOP;
   
   // funzioni utili
   public final int getOpCost() { return opcost; }
   public final int getOpQuantity() { return opquantity; }
   public final MagTag getCode() { return code; }
   public final short getOperation() { return operation; } 
   
   public UpdateOp(String code,
                   short oper,
                   int costindollars )
   {
      this( new MagTag(code), 
            oper,
            0,
            costindollars );
   }

   public UpdateOp(int quantity,
                   String code,
                   short oper)
   {
      this( new MagTag(code), 
            oper,
            quantity,
            0 );
   }

   public UpdateOp(String code,
                   short oper,
                   int quantity,
                   int costindollars )
   {
      this( new MagTag(code), 
            oper,
            quantity,
            costindollars );
   }

   public UpdateOp(MagTag code, 
                   short oper,
                   int quantity,
                   int costindollars )
   {
      this.opquantity = quantity;
      this.code = code;
      this.opcost = costindollars;
      operation |= oper;
   }
   
   public ITag getTag()
   {
      return code;
   }
   
   public String toString()
   {
      return "Operation on " + code.toString() + "\tType:" +
               getNextOutString() ;
   }
   
   private String getNextOutString()
   {
      String opstr = "";
      
      if((operation & MagConstants.COSTOP)!=0)
      {
         switch(operation)
         {
         case MagConstants.ADDCOST:
            opstr = "Adding cost " ; break;
         case MagConstants.SUBCOST:
            opstr = "Subtracting cost " ; break;
         case MagConstants.NEWCOST:
            opstr = "New cost " ; break;
         }
         
         opstr = opstr + opcost ;
      }
      
      if((operation & MagConstants.QUANTITYOP)!=0)
      {
         switch(operation)
         {
         case MagConstants.ADDQUANTITY:
            opstr = opstr + "\tAdding quantity " ; break;
         case MagConstants.SUBQUANTITY:
            opstr = opstr + "\tSubtracting quantity " ; break;
         case MagConstants.NEWQUANTITY:
            opstr = opstr + "\tNew quantity " ; break;
         }
         
         opstr = opstr + opquantity ;
      }
      
      return opstr;
   }
   
   // metodi di IRawData
   
   public int writeImage( DataOutputStream dataout ) throws IOException
   {
      dataout.writeShort(operation);
      
      if((operation & MagConstants.QUANTITYOP)!=0)
         dataout.writeInt(opquantity);
 
      if((operation & MagConstants.COSTOP)!=0)
         dataout.writeInt(opcost);
 
      char[] cd = code.toString().toCharArray();
      for (int i = 0; i < MagConstants.MAT_CODE_LEN ; i++)
         dataout.writeChar(cd[i]);
      
      return 1;
   } 
   
} // UpdateOp 




